#include "jc.h"
#include "filereader.h"

FileReader::FileReader(const char * filename, long bufferSize)
{
    m_bufferSize = bufferSize;
    m_buffer = NULL;
    m_handle = open(filename, O_RDONLY | O_BINARY);
    m_is_open = true;
    init();
}

FileReader::FileReader(int handle, long bufferSize)
{
    m_bufferSize = bufferSize;
    m_buffer = NULL;
    m_handle = handle;
    m_is_open = false;
    init();
}

FileReader::~FileReader()
{
    if(m_is_open) close(m_handle);

    if(m_buffer != NULL)
        delete []m_buffer;  
}

void FileReader::init()
{
    m_bufferIn = 0;
    m_bufferOut = 0;
    m_curPos = 0;

    if(checkStatus())
        m_buffer = new unsigned char[m_bufferSize];
}

bool FileReader::checkStatus() const
{
    return (m_handle > 0); 
}

int FileReader::getNextByte(unsigned char &ret)
{
    if(m_bufferIn == m_bufferOut)
    {
        m_curPos = lseek(m_handle,0,SEEK_CUR);
        m_bufferIn = read ( m_handle , m_buffer , m_bufferSize );
        if(m_bufferIn < 1) 
            return m_bufferIn;

        m_bufferOut = 0;
    }
    ret = m_buffer[m_bufferOut++];
    return 1;
}

long FileReader::getCurrentPosition()
{
    return m_curPos + m_bufferOut;
}
