#include "jc.h"
#include "filewriter.h"

FileWriter::FileWriter(const char * filename, long bufferSize)
{
    m_bufferSize = bufferSize;
    m_buffer = NULL;
    m_handle = open(filename, O_WRONLY | O_BINARY);
    init();
}

FileWriter::FileWriter(int handle, long bufferSize)
{
    m_bufferSize = bufferSize;
    m_buffer = NULL;
    m_handle = handle;
    init();
}

FileWriter::~FileWriter()
{
    setNextByte(0, true);

    if(m_buffer != NULL)
        delete []m_buffer;  
}

void FileWriter::init()
{
    m_bufferIn = 0;
    m_curPos = 0;

    if(checkStatus())
        m_buffer = new unsigned char[m_bufferSize];
}

bool FileWriter::checkStatus() const
{
    return (m_handle > 0); 
}

int FileWriter::setNextByte(unsigned char data, bool flash)
{
    if((m_bufferIn == m_bufferSize)||(flash))
    {
        long bufferOut = write ( m_handle , m_buffer , m_bufferIn );

        if(bufferOut < 1) 
            return bufferOut;

        if(bufferOut != m_bufferIn)
            return  0;

        m_curPos = lseek(m_handle,0,SEEK_CUR);
        m_bufferIn = 0;
    }

    m_buffer[m_bufferIn++] = data;
    return 1;
}

long FileWriter::getCurrentPosition()
{
    return m_curPos + m_bufferIn;
}
