#ifndef JPEGWRITER_H
#define JPEGWRITER_H

#include "jpegreader.h"

class JPEGWriter : public JPEGReader
{
public: 

    JPEGWriter();
    ~JPEGWriter();

    void    writeJPEGMarkerContent(char *src_filename, char *data_filename, char *tgt_filename);

protected:

    void scanInputFile(char * filename);
    void readDataFile(char * filename);
    void createNewFile(char *src_filename, char *tgt_filename);

    void processMarker(int marker);

    void copyData(long start_pos, long finish_pos, int src_handle, int tgt_handle);
    long writeMarker(int tgt_handle);

    void write1byte(unsigned char data, int handle);
    void write2bytes(unsigned int data, int handle);
    void write4bytes(unsigned long data, int handle);

private:

    unsigned long   m_appMarkerStart[2];
    unsigned long   m_appMarkerFinish[2];

    unsigned char   *m_dataBuffer;
    unsigned long   m_dataSize;
};

#endif

